import argparse
import os
import datetime
import csv
import time
from PIL import Image

FILE = 'File'
WIDTH = 'Width'
#HEIGHT = 'Height'
DELIMITER = ';'
print('(C) SergeySoft 2024 z-print@bk.ru')
print ("Массово меняет размер (разрешения) файлов указанных в csv-файле")
print ('Формат файла csv: File;Width Размеры указываются в мм, разделитель данных - ;')

parser = argparse.ArgumentParser()
parser.add_argument("-i", "--infolder", type=str, help = "Папка с исходными файлами")
parser.add_argument("-o", "--outfolder", type=str, help = "Папка дял обработанных файлов")
parser.add_argument("-l", "--list", type=str, help = "csv файл с именами файлов и размерами")
parser.add_argument("-d", "--delimiter",  type=str, help = "Разделитель данных в csv-файле. По умолчанию ;")
parser.add_argument("-v", "--verbose", action="store_true", help = "Выдавать промежуточную информацию во время исполнения")
# parser.add_argument("-h", "--help", type=str, help = "Массово изменяет размер (разрешение) файлов из списка с csv-файле")

delemiter_ = DELIMITER

args = parser.parse_args()

if args.list == None :
	print( "Не указан csv- файл c информацией о файлах и размерах")
	parser.print_help()
	quit()

if args.infolder == None :
	print( "Не указана папка с исходными файлами")
	parser.print_help()
	quit()
if args.outfolder == None :
	print( "Не указана папка для сохранения обработанных файлов. Рекомендуем сохранять файлы в отдельную папку")
	parser.print_help()
	quit()

if args.delimiter != '' :
	delemiter_ = args.delimiter

start = datetime.datetime.now() # запомним время начала работы программы

if args.verbose :
	print (f'Исходная папка {args.infolder}')
	print(f'Папка с результатами {args.outfolder}')
	print(f'файл со списком картинок и размерами в мм {args.list}')

with open(args.list, encoding="utf8") as f:
    csv_reader = csv.DictReader(f, delimiter = delimiter_)
    # print(csv_reader.line)
    # skip the header
    next(csv_reader)
    # show the data
    for line in csv_reader:
    	# if args.verbose :
    	# 	print (line)
        inFileName = os.path.join(args.infolder, line[FILE])
        outFile = os.path.join(args.outfolder, line[FILE])
        try:
        	with Image.open(inFileName) as im:
        		if args.verbose :
        			print(f'Обрабатывается файл {line[FILE]}')
        		# im.thumbnail(line[WIDTH], line[HEIGHT])
        		dpi_ = 25.4 * im.width / float(line[WIDTH])
        		#ydpi = 25.4 * im.height / float(line[HEIGHT]) 
        		im.save(outFile, dpi=(dpi_, dpi_))
        except IOError:
        	print(f'Не удалось обработать файл {inFileName}')

end = datetime.datetime.now() # запомним время окончания работы программы
print(f'Время обработки данных ', str(end - start))

print (f"Обработка окончена. Результаты папке {args.outfolder}")
